"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GuidelineBasedVariantClassification(ProtocolElement):
    """
    Variant classification based on guidlines, AMP and ACMG are supported
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "acmgVariantClassification": reports_6_5_0.AcmgVariantClassification,
            "ampVariantClassification": reports_6_5_0.AmpVariantClassification,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.AcmgVariantClassification": reports_6_5_0.AcmgVariantClassification,
            "org.gel.models.report.avro.AmpVariantClassification": reports_6_5_0.AmpVariantClassification,
            "org.gel.models.report.avro.GuidelineBasedVariantClassification": reports_6_5_0.GuidelineBasedVariantClassification,
        }

    __slots__ = [
        "acmgVariantClassification",
        "ampVariantClassification",
    ]

    def __init__(
        self,
        acmgVariantClassification=None,
        ampVariantClassification=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.GuidelineBasedVariantClassification model.

        :param acmgVariantClassification:
            Variant classification using ACMG framework
        :type acmgVariantClassification: None | AcmgVariantClassification
        :param ampVariantClassification:
            Variant classification using AMP framework
        :type ampVariantClassification: None | AmpVariantClassification
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
